# Organization

# Admin API Keys

## Create admin API key

**post** `/organization/admin_api_keys`

Create an organization admin API key

### Body Parameters

- `name: string`

- `expires_in_seconds: optional number`

  The number of seconds until the API key expires. Omit this field for a key that does not expire.

### Returns

- `value: string`

  The value of the API key. Only shown on create.

### Example

```http
curl https://api.openai.com/v1/organization/admin_api_keys \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
    -d '{
          "name": "New Admin Key",
          "expires_in_seconds": 2592000
        }'
```

#### Response

```json
{
  "id": "key_abc",
  "created_at": 1711471533,
  "expires_at": 1714063533,
  "object": "organization.admin_api_key",
  "owner": {
    "id": "sa_456",
    "created_at": 1711471533,
    "name": "My Service Account",
    "object": "organization.user",
    "role": "owner",
    "type": "user"
  },
  "redacted_value": "sk-admin...def",
  "last_used_at": 1711471534,
  "name": "Administration Key",
  "value": "sk-admin-1234abcd"
}
```

### Example

```http
curl -X POST https://api.openai.com/v1/organization/admin_api_keys \
  -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
  -H "Content-Type: application/json" \
  -d '{
      "name": "New Admin Key",
      "expires_in_seconds": 2592000
  }'
```

#### Response

```json
{
  "object": "organization.admin_api_key",
  "id": "key_xyz",
  "name": "New Admin Key",
  "redacted_value": "sk-admin...xyz",
  "created_at": 1711471533,
  "expires_at": 1714063533,
  "last_used_at": 1711471534,
  "owner": {
    "type": "user",
    "object": "organization.user",
    "id": "user_123",
    "name": "John Doe",
    "created_at": 1711471533,
    "role": "owner"
  },
  "value": "sk-admin-1234abcd"
}
```

## Delete admin API key

**delete** `/organization/admin_api_keys/{key_id}`

Delete an organization admin API key

### Path Parameters

- `key_id: string`

  The ID of the API key to be deleted.

### Returns

- `id: string`

- `deleted: boolean`

- `object: "organization.admin_api_key.deleted"`

  - `"organization.admin_api_key.deleted"`

### Example

```http
curl https://api.openai.com/v1/organization/admin_api_keys/$KEY_ID \
    -X DELETE \
    -H "Authorization: Bearer $OPENAI_ADMIN_KEY"
```

#### Response

```json
{
  "id": "key_abc",
  "deleted": true,
  "object": "organization.admin_api_key.deleted"
}
```

### Example

```http
curl -X DELETE https://api.openai.com/v1/organization/admin_api_keys/key_abc \
  -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
  -H "Content-Type: application/json"
```

#### Response

```json
{
  "id": "key_abc",
  "object": "organization.admin_api_key.deleted",
  "deleted": true
}
```

## List all organization and project API keys.

**get** `/organization/admin_api_keys`

List organization API keys

### Query Parameters

- `after: optional string or null`

  Return keys with IDs that come after this ID in the pagination order.

- `limit: optional number`

  Maximum number of keys to return.

- `order: optional "asc" or "desc"`

  Order results by creation time, ascending or descending.

  - `"asc"`

  - `"desc"`

### Returns

- `data: array of AdminAPIKey`

  - `id: string`

    The identifier, which can be referenced in API endpoints

  - `created_at: number`

    The Unix timestamp (in seconds) of when the API key was created

  - `expires_at: number or null`

    The Unix timestamp (in seconds) of when the API key expires

  - `object: "organization.admin_api_key"`

    The object type, which is always `organization.admin_api_key`

    - `"organization.admin_api_key"`

  - `owner: object { id, created_at, name, 3 more }`

    - `id: optional string`

      The identifier, which can be referenced in API endpoints

    - `created_at: optional number`

      The Unix timestamp (in seconds) of when the user was created

    - `name: optional string`

      The name of the user

    - `object: optional string`

      The object type, which is always organization.user

    - `role: optional string`

      Always `owner`

    - `type: optional string`

      Always `user`

  - `redacted_value: string`

    The redacted value of the API key

  - `last_used_at: optional number or null`

    The Unix timestamp (in seconds) of when the API key was last used

  - `name: optional string or null`

    The name of the API key

- `has_more: boolean`

- `object: "list"`

  - `"list"`

- `first_id: optional string or null`

- `last_id: optional string or null`

### Example

```http
curl https://api.openai.com/v1/organization/admin_api_keys \
    -H "Authorization: Bearer $OPENAI_ADMIN_KEY"
```

#### Response

```json
{
  "data": [
    {
      "id": "key_abc",
      "created_at": 1711471533,
      "expires_at": 1714063533,
      "object": "organization.admin_api_key",
      "owner": {
        "id": "sa_456",
        "created_at": 1711471533,
        "name": "My Service Account",
        "object": "organization.user",
        "role": "owner",
        "type": "user"
      },
      "redacted_value": "sk-admin...def",
      "last_used_at": 1711471534,
      "name": "Administration Key"
    }
  ],
  "has_more": false,
  "object": "list",
  "first_id": "key_abc",
  "last_id": "key_xyz"
}
```

### Example

```http
curl https://api.openai.com/v1/organization/admin_api_keys?after=key_abc&limit=20 \
  -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
  -H "Content-Type: application/json"
```

#### Response

```json
{
  "object": "list",
  "data": [
    {
      "object": "organization.admin_api_key",
      "id": "key_abc",
      "name": "Main Admin Key",
      "redacted_value": "sk-admin...def",
      "created_at": 1711471533,
      "expires_at": 1714063533,
      "last_used_at": 1711471534,
      "owner": {
        "type": "service_account",
        "object": "organization.service_account",
        "id": "sa_456",
        "name": "My Service Account",
        "created_at": 1711471533,
        "role": "member"
      }
    }
  ],
  "first_id": "key_abc",
  "last_id": "key_abc",
  "has_more": false
}
```

## Retrieve admin API key

**get** `/organization/admin_api_keys/{key_id}`

Retrieve a single organization API key

### Path Parameters

- `key_id: string`

  The ID of the API key.

### Returns

- `AdminAPIKey object { id, created_at, expires_at, 5 more }`

  Represents an individual Admin API key in an org.

  - `id: string`

    The identifier, which can be referenced in API endpoints

  - `created_at: number`

    The Unix timestamp (in seconds) of when the API key was created

  - `expires_at: number or null`

    The Unix timestamp (in seconds) of when the API key expires

  - `object: "organization.admin_api_key"`

    The object type, which is always `organization.admin_api_key`

    - `"organization.admin_api_key"`

  - `owner: object { id, created_at, name, 3 more }`

    - `id: optional string`

      The identifier, which can be referenced in API endpoints

    - `created_at: optional number`

      The Unix timestamp (in seconds) of when the user was created

    - `name: optional string`

      The name of the user

    - `object: optional string`

      The object type, which is always organization.user

    - `role: optional string`

      Always `owner`

    - `type: optional string`

      Always `user`

  - `redacted_value: string`

    The redacted value of the API key

  - `last_used_at: optional number or null`

    The Unix timestamp (in seconds) of when the API key was last used

  - `name: optional string or null`

    The name of the API key

### Example

```http
curl https://api.openai.com/v1/organization/admin_api_keys/$KEY_ID \
    -H "Authorization: Bearer $OPENAI_ADMIN_KEY"
```

#### Response

```json
{
  "id": "key_abc",
  "created_at": 1711471533,
  "expires_at": 1714063533,
  "object": "organization.admin_api_key",
  "owner": {
    "id": "sa_456",
    "created_at": 1711471533,
    "name": "My Service Account",
    "object": "organization.user",
    "role": "owner",
    "type": "user"
  },
  "redacted_value": "sk-admin...def",
  "last_used_at": 1711471534,
  "name": "Administration Key"
}
```

### Example

```http
curl https://api.openai.com/v1/organization/admin_api_keys/key_abc \
  -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
  -H "Content-Type: application/json"
```

#### Response

```json
{
  "object": "organization.admin_api_key",
  "id": "key_abc",
  "name": "Main Admin Key",
  "redacted_value": "sk-admin...xyz",
  "created_at": 1711471533,
  "expires_at": null,
  "last_used_at": 1711471534,
  "owner": {
    "type": "user",
    "object": "organization.user",
    "id": "user_123",
    "name": "John Doe",
    "created_at": 1711471533,
    "role": "owner"
  }
}
```

## Domain Types

### Admin API Key

- `AdminAPIKey object { id, created_at, expires_at, 5 more }`

  Represents an individual Admin API key in an org.

  - `id: string`

    The identifier, which can be referenced in API endpoints

  - `created_at: number`

    The Unix timestamp (in seconds) of when the API key was created

  - `expires_at: number or null`

    The Unix timestamp (in seconds) of when the API key expires

  - `object: "organization.admin_api_key"`

    The object type, which is always `organization.admin_api_key`

    - `"organization.admin_api_key"`

  - `owner: object { id, created_at, name, 3 more }`

    - `id: optional string`

      The identifier, which can be referenced in API endpoints

    - `created_at: optional number`

      The Unix timestamp (in seconds) of when the user was created

    - `name: optional string`

      The name of the user

    - `object: optional string`

      The object type, which is always organization.user

    - `role: optional string`

      Always `owner`

    - `type: optional string`

      Always `user`

  - `redacted_value: string`

    The redacted value of the API key

  - `last_used_at: optional number or null`

    The Unix timestamp (in seconds) of when the API key was last used

  - `name: optional string or null`

    The name of the API key

### Admin API Key Create Response

- `AdminAPIKeyCreateResponse = AdminAPIKey`

  Represents an individual Admin API key in an org.

  - `value: string`

    The value of the API key. Only shown on create.

### Admin API Key Delete Response

- `AdminAPIKeyDeleteResponse object { id, deleted, object }`

  - `id: string`

  - `deleted: boolean`

  - `object: "organization.admin_api_key.deleted"`

    - `"organization.admin_api_key.deleted"`

# Audit Logs

## List audit logs

**get** `/organization/audit_logs`

List user actions and configuration changes within this organization.

### Query Parameters

- `actor_emails: optional array of string`

  Return only events performed by users with these emails.

- `actor_ids: optional array of string`

  Return only events performed by these actors. Can be a user ID, a service account ID, or an api key tracking ID.

- `after: optional string`

  A cursor for use in pagination. `after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include after=obj_foo in order to fetch the next page of the list.

- `before: optional string`

  A cursor for use in pagination. `before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with obj_foo, your subsequent call can include before=obj_foo in order to fetch the previous page of the list.

- `effective_at: optional object { gt, gte, lt, lte }`

  Return only events whose `effective_at` (Unix seconds) is in this range.

  - `gt: optional number`

    Return only events whose `effective_at` (Unix seconds) is greater than this value.

  - `gte: optional number`

    Return only events whose `effective_at` (Unix seconds) is greater than or equal to this value.

  - `lt: optional number`

    Return only events whose `effective_at` (Unix seconds) is less than this value.

  - `lte: optional number`

    Return only events whose `effective_at` (Unix seconds) is less than or equal to this value.

- `event_types: optional array of "api_key.created" or "api_key.updated" or "api_key.deleted" or 146 more`

  Return only events with a `type` in one of these values. For example, `project.created`. For all options, see the documentation for the [audit log object](/api/reference/resources/admin/subresources/organization/subresources/audit_logs).

  - `"api_key.created"`

  - `"api_key.updated"`

  - `"api_key.deleted"`

  - `"certificate.created"`

  - `"certificate.updated"`

  - `"certificate.deleted"`

  - `"certificates.activated"`

  - `"certificates.deactivated"`

  - `"checkpoint.permission.created"`

  - `"checkpoint.permission.deleted"`

  - `"external_key.registered"`

  - `"external_key.removed"`

  - `"external_storage.registered"`

  - `"external_storage.removed"`

  - `"group.created"`

  - `"group.updated"`

  - `"group.deleted"`

  - `"invite.sent"`

  - `"invite.accepted"`

  - `"invite.deleted"`

  - `"ip_allowlist.created"`

  - `"ip_allowlist.updated"`

  - `"ip_allowlist.deleted"`

  - `"ip_allowlist.config.activated"`

  - `"ip_allowlist.config.deactivated"`

  - `"login.succeeded"`

  - `"login.failed"`

  - `"logout.succeeded"`

  - `"logout.failed"`

  - `"organization.updated"`

  - `"project.created"`

  - `"project.updated"`

  - `"project.archived"`

  - `"project.deleted"`

  - `"rate_limit.updated"`

  - `"rate_limit.deleted"`

  - `"resource.deleted"`

  - `"tunnel.created"`

  - `"tunnel.updated"`

  - `"tunnel.deleted"`

  - `"workload_identity_provider.created"`

  - `"workload_identity_provider.updated"`

  - `"workload_identity_provider.deleted"`

  - `"workload_identity_provider_mapping.created"`

  - `"workload_identity_provider_mapping.updated"`

  - `"workload_identity_provider_mapping.deleted"`

  - `"role.created"`

  - `"role.updated"`

  - `"role.deleted"`

  - `"role.assignment.created"`

  - `"role.assignment.deleted"`

  - `"role.bound_to_resource"`

  - `"role.unbound_from_resource"`

  - `"scim.enabled"`

  - `"scim.disabled"`

  - `"service_account.created"`

  - `"service_account.updated"`

  - `"service_account.deleted"`

  - `"user.added"`

  - `"user.updated"`

  - `"user.deleted"`

  - `"tenant.metadata.updated"`

  - `"tenant.microsoft_entra_mapping.upserted"`

  - `"tenant.microsoft_entra_mapping.deleted"`

  - `"tenant.workload_identity.provider.created"`

  - `"tenant.workload_identity.provider.updated"`

  - `"tenant.workload_identity.provider.archived"`

  - `"tenant.workload_identity.mapping.created"`

  - `"tenant.workload_identity.mapping.updated"`

  - `"tenant.workload_identity.mapping.archived"`

  - `"tenant.workload_identity.binding.created"`

  - `"tenant.workload_identity.principal.provisioned"`

  - `"tenant.workload_identity.access_token.issued"`

  - `"tenant.admin_api_key.created"`

  - `"tenant.admin_api_key.updated"`

  - `"tenant.admin_api_key.deleted"`

  - `"tenant.project_api_key.created"`

  - `"tenant.trusted_access.business_verification.started"`

  - `"tenant.trusted_access.application.submitted"`

  - `"tenant.chatgpt_access_token.revoked"`

  - `"tenant.migration.completed"`

  - `"tenant.sso.migrated"`

  - `"tenant.domains.migrated"`

  - `"tenant.sso_connection.created"`

  - `"tenant.sso_connection.updated"`

  - `"tenant.sso_connection.deleted"`

  - `"tenant.sso_connection.setup.started"`

  - `"tenant.policy.created"`

  - `"tenant.policy.updated"`

  - `"tenant.policy.deleted"`

  - `"tenant.policy.attached"`

  - `"tenant.policy.detached"`

  - `"tenant.principal_authentication_policy.resolved"`

  - `"tenant.scim.setup.started"`

  - `"tenant.scim.deletion.requested"`

  - `"tenant.scim.directory.created"`

  - `"tenant.product_access_policy.updated"`

  - `"tenant.resource_share_grant.created"`

  - `"tenant.resource_share_grant.updated"`

  - `"tenant.resource_share_grant.accepted"`

  - `"tenant.resource_share_grant.declined"`

  - `"tenant.resource_share_grant.revoked"`

  - `"tenant.resource_share_grant.deleted"`

  - `"tenant.service_account.updated"`

  - `"tenant.service_account.deleted"`

  - `"tenant.service_account.token.revoked"`

  - `"tenant.billing.overage_limit.updated"`

  - `"tenant.billing.alerts.updated"`

  - `"tenant.billing.info.updated"`

  - `"tenant.usage_limit.workspace.updated"`

  - `"tenant.usage_limit.group.updated"`

  - `"tenant.usage_limit.user.updated"`

  - `"tenant.usage_limit.increase_request.updated"`

  - `"tenant.usage_limit.increase_request.resolved"`

  - `"tenant.group.created"`

  - `"tenant.group.updated"`

  - `"tenant.group.deleted"`

  - `"tenant.group.member.added"`

  - `"tenant.group.member.removed"`

  - `"tenant.migration_rollout.status.updated"`

  - `"tenant.migration_rollout.tier.updated"`

  - `"tenant.role.metadata.updated"`

  - `"tenant.custom_role.created"`

  - `"tenant.custom_role.updated"`

  - `"tenant.custom_role.deleted"`

  - `"tenant.role_assignment.created"`

  - `"tenant.role_assignment.deleted"`

  - `"tenant.resource_role_assignment.created"`

  - `"tenant.resource_role_assignment.deleted"`

  - `"tenant.resource_access.updated"`

  - `"tenant.resource_access.deleted"`

  - `"tenant.ads_account.onboarding.redemption"`

  - `"tenant.session_policy.created"`

  - `"tenant.session_policy.updated"`

  - `"tenant.session_policy.deleted"`

  - `"tenant.session_revocation.started"`

  - `"tenant.third_party_app_policy.updated"`

  - `"tenant.user.added"`

  - `"tenant.user.updated"`

  - `"tenant.user.removed"`

  - `"tenant.user.looked_up"`

  - `"tenant.user.invited"`

  - `"tenant.membership.revoked"`

  - `"tenant.api_organization_invite.upserted"`

  - `"tenant.api_organization_invite.deleted"`

  - `"tenant.chatgpt_workspace_invite.upserted"`

  - `"tenant.membership.accepted"`

  - `"tenant.membership.declined"`

  - `"tenant.workspace_invite_email_settings.updated"`

- `limit: optional number`

  A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 20.

- `project_ids: optional array of string`

  Return only events for these projects.

- `resource_ids: optional array of string`

  Return only events performed on these targets. For example, a project ID updated. For ChatGPT connector role events, use the workspace connector resource ID shown in `details.id`, such as `<workspace_id>__<connector_id>`.

- `tenant_only: optional boolean`

  Return only tenant-scoped events associated with this organization. Required for tenant-scoped events such as `role.bound_to_resource` and `role.unbound_from_resource`. When `true`, all supplied event types must be tenant-scoped.

### Returns

- `data: array of object { id, effective_at, type, 59 more }`

  - `id: string`

    The ID of this log.

  - `effective_at: number`

    The Unix timestamp (in seconds) of the event.

  - `type: "api_key.created" or "api_key.updated" or "api_key.deleted" or 146 more`

    The event type.

    - `"api_key.created"`

    - `"api_key.updated"`

    - `"api_key.deleted"`

    - `"certificate.created"`

    - `"certificate.updated"`

    - `"certificate.deleted"`

    - `"certificates.activated"`

    - `"certificates.deactivated"`

    - `"checkpoint.permission.created"`

    - `"checkpoint.permission.deleted"`

    - `"external_key.registered"`

    - `"external_key.removed"`

    - `"external_storage.registered"`

    - `"external_storage.removed"`

    - `"group.created"`

    - `"group.updated"`

    - `"group.deleted"`

    - `"invite.sent"`

    - `"invite.accepted"`

    - `"invite.deleted"`

    - `"ip_allowlist.created"`

    - `"ip_allowlist.updated"`

    - `"ip_allowlist.deleted"`

    - `"ip_allowlist.config.activated"`

    - `"ip_allowlist.config.deactivated"`

    - `"login.succeeded"`

    - `"login.failed"`

    - `"logout.succeeded"`

    - `"logout.failed"`

    - `"organization.updated"`

    - `"project.created"`

    - `"project.updated"`

    - `"project.archived"`

    - `"project.deleted"`

    - `"rate_limit.updated"`

    - `"rate_limit.deleted"`

    - `"resource.deleted"`

    - `"tunnel.created"`

    - `"tunnel.updated"`

    - `"tunnel.deleted"`

    - `"workload_identity_provider.created"`

    - `"workload_identity_provider.updated"`

    - `"workload_identity_provider.deleted"`

    - `"workload_identity_provider_mapping.created"`

    - `"workload_identity_provider_mapping.updated"`

    - `"workload_identity_provider_mapping.deleted"`

    - `"role.created"`

    - `"role.updated"`

    - `"role.deleted"`

    - `"role.assignment.created"`

    - `"role.assignment.deleted"`

    - `"role.bound_to_resource"`

    - `"role.unbound_from_resource"`

    - `"scim.enabled"`

    - `"scim.disabled"`

    - `"service_account.created"`

    - `"service_account.updated"`

    - `"service_account.deleted"`

    - `"user.added"`

    - `"user.updated"`

    - `"user.deleted"`

    - `"tenant.metadata.updated"`

    - `"tenant.microsoft_entra_mapping.upserted"`

    - `"tenant.microsoft_entra_mapping.deleted"`

    - `"tenant.workload_identity.provider.created"`

    - `"tenant.workload_identity.provider.updated"`

    - `"tenant.workload_identity.provider.archived"`

    - `"tenant.workload_identity.mapping.created"`

    - `"tenant.workload_identity.mapping.updated"`

    - `"tenant.workload_identity.mapping.archived"`

    - `"tenant.workload_identity.binding.created"`

    - `"tenant.workload_identity.principal.provisioned"`

    - `"tenant.workload_identity.access_token.issued"`

    - `"tenant.admin_api_key.created"`

    - `"tenant.admin_api_key.updated"`

    - `"tenant.admin_api_key.deleted"`

    - `"tenant.project_api_key.created"`

    - `"tenant.trusted_access.business_verification.started"`

    - `"tenant.trusted_access.application.submitted"`

    - `"tenant.chatgpt_access_token.revoked"`

    - `"tenant.migration.completed"`

    - `"tenant.sso.migrated"`

    - `"tenant.domains.migrated"`

    - `"tenant.sso_connection.created"`

    - `"tenant.sso_connection.updated"`

    - `"tenant.sso_connection.deleted"`

    - `"tenant.sso_connection.setup.started"`

    - `"tenant.policy.created"`

    - `"tenant.policy.updated"`

    - `"tenant.policy.deleted"`

    - `"tenant.policy.attached"`

    - `"tenant.policy.detached"`

    - `"tenant.principal_authentication_policy.resolved"`

    - `"tenant.scim.setup.started"`

    - `"tenant.scim.deletion.requested"`

    - `"tenant.scim.directory.created"`

    - `"tenant.product_access_policy.updated"`

    - `"tenant.resource_share_grant.created"`

    - `"tenant.resource_share_grant.updated"`

    - `"tenant.resource_share_grant.accepted"`

    - `"tenant.resource_share_grant.declined"`

    - `"tenant.resource_share_grant.revoked"`

    - `"tenant.resource_share_grant.deleted"`

    - `"tenant.service_account.updated"`

    - `"tenant.service_account.deleted"`

    - `"tenant.service_account.token.revoked"`

    - `"tenant.billing.overage_limit.updated"`

    - `"tenant.billing.alerts.updated"`

    - `"tenant.billing.info.updated"`

    - `"tenant.usage_limit.workspace.updated"`

    - `"tenant.usage_limit.group.updated"`

    - `"tenant.usage_limit.user.updated"`

    - `"tenant.usage_limit.increase_request.updated"`

    - `"tenant.usage_limit.increase_request.resolved"`

    - `"tenant.group.created"`

    - `"tenant.group.updated"`

    - `"tenant.group.deleted"`

    - `"tenant.group.member.added"`

    - `"tenant.group.member.removed"`

    - `"tenant.migration_rollout.status.updated"`

    - `"tenant.migration_rollout.tier.updated"`

    - `"tenant.role.metadata.updated"`

    - `"tenant.custom_role.created"`

    - `"tenant.custom_role.updated"`

    - `"tenant.custom_role.deleted"`

    - `"tenant.role_assignment.created"`

    - `"tenant.role_assignment.deleted"`

    - `"tenant.resource_role_assignment.created"`

    - `"tenant.resource_role_assignment.deleted"`

    - `"tenant.resource_access.updated"`

    - `"tenant.resource_access.deleted"`

    - `"tenant.ads_account.onboarding.redemption"`

    - `"tenant.session_policy.created"`

    - `"tenant.session_policy.updated"`

    - `"tenant.session_policy.deleted"`

    - `"tenant.session_revocation.started"`

    - `"tenant.third_party_app_policy.updated"`

    - `"tenant.user.added"`

    - `"tenant.user.updated"`

    - `"tenant.user.removed"`

    - `"tenant.user.looked_up"`

    - `"tenant.user.invited"`

    - `"tenant.membership.revoked"`

    - `"tenant.api_organization_invite.upserted"`

    - `"tenant.api_organization_invite.deleted"`

    - `"tenant.chatgpt_workspace_invite.upserted"`

    - `"tenant.membership.accepted"`

    - `"tenant.membership.declined"`

    - `"tenant.workspace_invite_email_settings.updated"`

  - `actor: optional object { api_key, session, type }  or null`

    The actor who performed the audit logged action.

    - `api_key: optional object { id, service_account, type, user }`

      The API Key used to perform the audit logged action.

      - `id: optional string`

        The tracking id of the API key.

      - `service_account: optional object { id }`

        The service account that performed the audit logged action.

        - `id: optional string`

          The service account id.

      - `type: optional "user" or "service_account"`

        The type of API key. Can be either `user` or `service_account`.

        - `"user"`

        - `"service_account"`

      - `user: optional object { id, email }`

        The user who performed the audit logged action.

        - `id: optional string`

          The user id.

        - `email: optional string`

          The user email.

    - `session: optional object { ip_address, user }`

      The session in which the audit logged action was performed.

      - `ip_address: optional string`

        The IP address from which the action was performed.

      - `user: optional object { id, email }`

        The user who performed the audit logged action.

        - `id: optional string`

          The user id.

        - `email: optional string`

          The user email.

    - `type: optional "session" or "api_key"`

      The type of actor. Is either `session` or `api_key`.

      - `"session"`

      - `"api_key"`

  - `"api_key.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The tracking ID of the API key.

    - `data: optional object { scopes }`

      The payload used to create the API key.

      - `scopes: optional array of string`

        A list of scopes allowed for the API key, e.g. `["api.model.request"]`

  - `"api_key.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The tracking ID of the API key.

  - `"api_key.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The tracking ID of the API key.

    - `changes_requested: optional object { scopes }`

      The payload used to update the API key.

      - `scopes: optional array of string`

        A list of scopes allowed for the API key, e.g. `["api.model.request"]`

  - `"certificate.created": optional object { id, name }`

    The details for events with this `type`.

    - `id: optional string`

      The certificate ID.

    - `name: optional string`

      The name of the certificate.

  - `"certificate.deleted": optional object { id, certificate, name }`

    The details for events with this `type`.

    - `id: optional string`

      The certificate ID.

    - `certificate: optional string`

      The certificate content in PEM format.

    - `name: optional string`

      The name of the certificate.

  - `"certificate.updated": optional object { id, name }`

    The details for events with this `type`.

    - `id: optional string`

      The certificate ID.

    - `name: optional string`

      The name of the certificate.

  - `"certificates.activated": optional object { certificates }`

    The details for events with this `type`.

    - `certificates: optional array of object { id, name }`

      - `id: optional string`

        The certificate ID.

      - `name: optional string`

        The name of the certificate.

  - `"certificates.deactivated": optional object { certificates }`

    The details for events with this `type`.

    - `certificates: optional array of object { id, name }`

      - `id: optional string`

        The certificate ID.

      - `name: optional string`

        The name of the certificate.

  - `"checkpoint.permission.created": optional object { id, data }`

    The project and fine-tuned model checkpoint that the checkpoint permission was created for.

    - `id: optional string`

      The ID of the checkpoint permission.

    - `data: optional object { fine_tuned_model_checkpoint, project_id }`

      The payload used to create the checkpoint permission.

      - `fine_tuned_model_checkpoint: optional string`

        The ID of the fine-tuned model checkpoint.

      - `project_id: optional string`

        The ID of the project that the checkpoint permission was created for.

  - `"checkpoint.permission.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the checkpoint permission.

  - `"external_key.registered": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the external key configuration.

    - `data: optional unknown`

      The configuration for the external key.

  - `"external_key.removed": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the external key configuration.

  - `"external_storage.registered": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the external storage configuration.

    - `data: optional object { geography, provider }`

      The configuration for the external storage.

      - `geography: optional string`

        The OpenAI geography derived from the storage region.

      - `provider: optional AwsExternalStorageProvider or AzureExternalStorageProvider or GcpExternalStorageProvider or OciExternalStorageProvider`

        The external storage provider configuration.

        - `AwsExternalStorageProvider object { account_id, bucket, external_id, 3 more }`

          - `account_id: string`

          - `bucket: string`

          - `external_id: string`

          - `region: string`

          - `role_arn: string`

          - `type: "aws"`

            - `"aws"`

        - `AzureExternalStorageProvider object { account_name, container, region, 4 more }`

          - `account_name: string`

          - `container: string`

          - `region: string`

          - `resource_group: string`

          - `subscription_id: string`

          - `tenant_id: string`

          - `type: "azure"`

            - `"azure"`

        - `GcpExternalStorageProvider object { audience, bucket, region, 4 more }`

          - `audience: string`

          - `bucket: string`

          - `region: string`

          - `type: "gcp"`

            - `"gcp"`

          - `workload_identity_pool_id: string`

          - `workload_identity_project_number: string`

          - `workload_identity_provider_id: string`

        - `OciExternalStorageProvider object { bucket, region, tenancy_ocid, type }`

          - `bucket: string`

          - `region: string`

          - `tenancy_ocid: string`

          - `type: "oci"`

            - `"oci"`

  - `"external_storage.removed": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the external storage configuration.

  - `"group.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the group.

    - `data: optional object { group_name }`

      Information about the created group.

      - `group_name: optional string`

        The group name.

  - `"group.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the group.

  - `"group.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the group.

    - `changes_requested: optional object { group_name }`

      The payload used to update the group.

      - `group_name: optional string`

        The updated group name.

  - `"invite.accepted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the invite.

  - `"invite.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the invite.

  - `"invite.sent": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the invite.

    - `data: optional object { email, role }`

      The payload used to create the invite.

      - `email: optional string`

        The email invited to the organization.

      - `role: optional string`

        The role the email was invited to be. Is either `owner` or `member`.

  - `"ip_allowlist.config.activated": optional object { configs }`

    The details for events with this `type`.

    - `configs: optional array of object { id, name }`

      The configurations that were activated.

      - `id: optional string`

        The ID of the IP allowlist configuration.

      - `name: optional string`

        The name of the IP allowlist configuration.

  - `"ip_allowlist.config.deactivated": optional object { configs }`

    The details for events with this `type`.

    - `configs: optional array of object { id, name }`

      The configurations that were deactivated.

      - `id: optional string`

        The ID of the IP allowlist configuration.

      - `name: optional string`

        The name of the IP allowlist configuration.

  - `"ip_allowlist.created": optional object { id, allowed_ips, name }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the IP allowlist configuration.

    - `allowed_ips: optional array of string`

      The IP addresses or CIDR ranges included in the configuration.

    - `name: optional string`

      The name of the IP allowlist configuration.

  - `"ip_allowlist.deleted": optional object { id, allowed_ips, name }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the IP allowlist configuration.

    - `allowed_ips: optional array of string`

      The IP addresses or CIDR ranges that were in the configuration.

    - `name: optional string`

      The name of the IP allowlist configuration.

  - `"ip_allowlist.updated": optional object { id, allowed_ips }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the IP allowlist configuration.

    - `allowed_ips: optional array of string`

      The updated set of IP addresses or CIDR ranges in the configuration.

  - `"login.failed": optional object { error_code, error_message }`

    The details for events with this `type`.

    - `error_code: optional string`

      The error code of the failure.

    - `error_message: optional string`

      The error message of the failure.

  - `"login.succeeded": optional unknown`

    This event has no additional fields beyond the standard audit log attributes.

  - `"logout.failed": optional object { error_code, error_message }`

    The details for events with this `type`.

    - `error_code: optional string`

      The error code of the failure.

    - `error_message: optional string`

      The error message of the failure.

  - `"logout.succeeded": optional unknown`

    This event has no additional fields beyond the standard audit log attributes.

  - `"organization.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The organization ID.

    - `changes_requested: optional object { api_call_logging, api_call_logging_project_ids, description, 4 more }`

      The payload used to update the organization settings.

      - `api_call_logging: optional string`

        How your organization logs data from supported API calls. One of `disabled`, `enabled_per_call`, `enabled_for_all_projects`, or `enabled_for_selected_projects`

      - `api_call_logging_project_ids: optional string`

        The list of project ids if api_call_logging is set to `enabled_for_selected_projects`

      - `description: optional string`

        The organization description.

      - `name: optional string`

        The organization name.

      - `threads_ui_visibility: optional string`

        Visibility of the threads page which shows messages created with the Assistants API and Playground. One of `ANY_ROLE`, `OWNERS`, or `NONE`.

      - `title: optional string`

        The organization title.

      - `usage_dashboard_visibility: optional string`

        Visibility of the usage dashboard which shows activity and costs for your organization. One of `ANY_ROLE` or `OWNERS`.

  - `project: optional object { id, name }`

    The project that the action was scoped to. Absent for actions not scoped to projects. Note that any admin actions taken via Admin API keys are associated with the default project.

    - `id: optional string`

      The project ID.

    - `name: optional string`

      The project title.

  - `"project.archived": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

  - `"project.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

    - `data: optional object { name, title }`

      The payload used to create the project.

      - `name: optional string`

        The project name.

      - `title: optional string`

        The title of the project as seen on the dashboard.

  - `"project.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

  - `"project.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

    - `changes_requested: optional object { title }`

      The payload used to update the project.

      - `title: optional string`

        The title of the project as seen on the dashboard.

  - `"rate_limit.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The rate limit ID

  - `"rate_limit.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The rate limit ID

    - `changes_requested: optional object { batch_1_day_max_input_tokens, max_audio_megabytes_per_1_minute, max_images_per_1_minute, 3 more }`

      The payload used to update the rate limits.

      - `batch_1_day_max_input_tokens: optional number`

        The maximum batch input tokens per day. Only relevant for certain models.

      - `max_audio_megabytes_per_1_minute: optional number`

        The maximum audio megabytes per minute. Only relevant for certain models.

      - `max_images_per_1_minute: optional number`

        The maximum images per minute. Only relevant for certain models.

      - `max_requests_per_1_day: optional number`

        The maximum requests per day. Only relevant for certain models.

      - `max_requests_per_1_minute: optional number`

        The maximum requests per minute.

      - `max_tokens_per_1_minute: optional number`

        The maximum tokens per minute.

  - `"role.assignment.created": optional object { id, principal_id, principal_type, 2 more }`

    The details for events with this `type`.

    - `id: optional string`

      The identifier of the role assignment.

    - `principal_id: optional string`

      The principal (user or group) that received the role.

    - `principal_type: optional string`

      The type of principal (user or group) that received the role.

    - `resource_id: optional string`

      The resource the role assignment is scoped to.

    - `resource_type: optional string`

      The type of resource the role assignment is scoped to.

  - `"role.assignment.deleted": optional object { id, principal_id, principal_type, 2 more }`

    The details for events with this `type`.

    - `id: optional string`

      The identifier of the role assignment.

    - `principal_id: optional string`

      The principal (user or group) that had the role removed.

    - `principal_type: optional string`

      The type of principal (user or group) that had the role removed.

    - `resource_id: optional string`

      The resource the role assignment was scoped to.

    - `resource_type: optional string`

      The type of resource the role assignment was scoped to.

  - `"role.bound_to_resource": optional object { id, connector_id, connector_name, 7 more }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the resource the role was bound to. ChatGPT workspace connector resources use `<workspace_id>__<connector_id>`.

    - `connector_id: optional string`

      The connector ID for a ChatGPT workspace connector resource.

    - `connector_name: optional string`

      The connector display name for a ChatGPT workspace connector resource, or the connector ID when the display name could not be resolved.

    - `enabled: optional boolean`

      Whether the connector is enabled for the role.

    - `permissions: optional array of string`

      The permissions granted to the role for the resource.

    - `resource_id: optional string`

      The ID of the resource the role was bound to.

    - `resource_type: optional string`

      The type of resource the role was bound to.

    - `role_id: optional string`

      The ID of the role that was bound to the resource.

    - `source: optional "role_toggle" or "role_connector_update" or "role_delete" or 2 more`

      The connector role mutation path that produced the event.

      - `"role_toggle"`

      - `"role_connector_update"`

      - `"role_delete"`

      - `"workspace_permissions"`

      - `"connector_publish"`

    - `workspace_id: optional string`

      The workspace ID for a ChatGPT workspace connector resource.

  - `"role.created": optional object { id, permissions, resource_id, 2 more }`

    The details for events with this `type`.

    - `id: optional string`

      The role ID.

    - `permissions: optional array of string`

      The permissions granted by the role.

    - `resource_id: optional string`

      The resource the role is scoped to.

    - `resource_type: optional string`

      The type of resource the role belongs to.

    - `role_name: optional string`

      The name of the role.

  - `"role.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The role ID.

  - `"role.unbound_from_resource": optional object { id, connector_id, connector_name, 7 more }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the resource the role was unbound from. ChatGPT workspace connector resources use `<workspace_id>__<connector_id>`.

    - `connector_id: optional string`

      The connector ID for a ChatGPT workspace connector resource.

    - `connector_name: optional string`

      The connector display name for a ChatGPT workspace connector resource, or the connector ID when the display name could not be resolved.

    - `enabled: optional boolean`

      Whether the connector is enabled for the role.

    - `permissions: optional array of string`

      The permissions remaining for the role after the change.

    - `resource_id: optional string`

      The ID of the resource the role was unbound from.

    - `resource_type: optional string`

      The type of resource the role was unbound from.

    - `role_id: optional string`

      The ID of the role that was unbound from the resource.

    - `source: optional "role_toggle" or "role_connector_update" or "role_delete" or 2 more`

      The connector role mutation path that produced the event.

      - `"role_toggle"`

      - `"role_connector_update"`

      - `"role_delete"`

      - `"workspace_permissions"`

      - `"connector_publish"`

    - `workspace_id: optional string`

      The workspace ID for a ChatGPT workspace connector resource.

  - `"role.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The role ID.

    - `changes_requested: optional object { description, metadata, permissions_added, 4 more }`

      The payload used to update the role.

      - `description: optional string`

        The updated role description, when provided.

      - `metadata: optional unknown`

        Additional metadata stored on the role.

      - `permissions_added: optional array of string`

        The permissions added to the role.

      - `permissions_removed: optional array of string`

        The permissions removed from the role.

      - `resource_id: optional string`

        The resource the role is scoped to.

      - `resource_type: optional string`

        The type of resource the role belongs to.

      - `role_name: optional string`

        The updated role name, when provided.

  - `"scim.disabled": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the SCIM was disabled for.

  - `"scim.enabled": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the SCIM was enabled for.

  - `"service_account.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The service account ID.

    - `data: optional object { role }`

      The payload used to create the service account.

      - `role: optional string`

        The role of the service account. Is either `owner` or `member`.

  - `"service_account.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The service account ID.

  - `"service_account.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The service account ID.

    - `changes_requested: optional object { role }`

      The payload used to updated the service account.

      - `role: optional string`

        The role of the service account. Is either `owner` or `member`.

  - `"user.added": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The user ID.

    - `data: optional object { role }`

      The payload used to add the user to the project.

      - `role: optional string`

        The role of the user. Is either `owner` or `member`.

  - `"user.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The user ID.

  - `"user.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

    - `changes_requested: optional object { role }`

      The payload used to update the user.

      - `role: optional string`

        The role of the user. Is either `owner` or `member`.

  - `"workload_identity_provider_mapping.created": optional object { id, data, identity_provider_id }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider mapping ID.

    - `data: optional unknown`

      The payload used to create the workload identity provider mapping.

    - `identity_provider_id: optional string`

      The workload identity provider ID.

  - `"workload_identity_provider_mapping.deleted": optional object { id, identity_provider_id, project_id, service_account_id }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider mapping ID.

    - `identity_provider_id: optional string`

      The workload identity provider ID.

    - `project_id: optional string`

      The project ID.

    - `service_account_id: optional string`

      The mapped service account ID.

  - `"workload_identity_provider_mapping.updated": optional object { id, changes_requested, identity_provider_id }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider mapping ID.

    - `changes_requested: optional unknown`

      The payload used to update the workload identity provider mapping.

    - `identity_provider_id: optional string`

      The workload identity provider ID.

  - `"workload_identity_provider.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider ID.

    - `data: optional unknown`

      The payload used to create the workload identity provider.

  - `"workload_identity_provider.deleted": optional object { id, name }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider ID.

    - `name: optional string`

      The workload identity provider name.

  - `"workload_identity_provider.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider ID.

    - `changes_requested: optional unknown`

      The payload used to update the workload identity provider.

- `has_more: boolean`

- `object: "list"`

  - `"list"`

- `first_id: optional string or null`

- `last_id: optional string or null`

### Example

```http
curl https://api.openai.com/v1/organization/audit_logs \
    -H "Authorization: Bearer $OPENAI_ADMIN_KEY"
```

#### Response

```json
{
  "data": [
    {
      "id": "id",
      "effective_at": 0,
      "type": "api_key.created",
      "actor": {
        "api_key": {
          "id": "id",
          "service_account": {
            "id": "id"
          },
          "type": "user",
          "user": {
            "id": "id",
            "email": "email"
          }
        },
        "session": {
          "ip_address": "ip_address",
          "user": {
            "id": "id",
            "email": "email"
          }
        },
        "type": "session"
      },
      "api_key.created": {
        "id": "id",
        "data": {
          "scopes": [
            "string"
          ]
        }
      },
      "api_key.deleted": {
        "id": "id"
      },
      "api_key.updated": {
        "id": "id",
        "changes_requested": {
          "scopes": [
            "string"
          ]
        }
      },
      "certificate.created": {
        "id": "id",
        "name": "name"
      },
      "certificate.deleted": {
        "id": "id",
        "certificate": "certificate",
        "name": "name"
      },
      "certificate.updated": {
        "id": "id",
        "name": "name"
      },
      "certificates.activated": {
        "certificates": [
          {
            "id": "id",
            "name": "name"
          }
        ]
      },
      "certificates.deactivated": {
        "certificates": [
          {
            "id": "id",
            "name": "name"
          }
        ]
      },
      "checkpoint.permission.created": {
        "id": "id",
        "data": {
          "fine_tuned_model_checkpoint": "fine_tuned_model_checkpoint",
          "project_id": "project_id"
        }
      },
      "checkpoint.permission.deleted": {
        "id": "id"
      },
      "external_key.registered": {
        "id": "id",
        "data": {}
      },
      "external_key.removed": {
        "id": "id"
      },
      "external_storage.registered": {
        "id": "id",
        "data": {
          "geography": "geography",
          "provider": {
            "account_id": "account_id",
            "bucket": "bucket",
            "external_id": "external_id",
            "region": "region",
            "role_arn": "role_arn",
            "type": "aws"
          }
        }
      },
      "external_storage.removed": {
        "id": "id"
      },
      "group.created": {
        "id": "id",
        "data": {
          "group_name": "group_name"
        }
      },
      "group.deleted": {
        "id": "id"
      },
      "group.updated": {
        "id": "id",
        "changes_requested": {
          "group_name": "group_name"
        }
      },
      "invite.accepted": {
        "id": "id"
      },
      "invite.deleted": {
        "id": "id"
      },
      "invite.sent": {
        "id": "id",
        "data": {
          "email": "email",
          "role": "role"
        }
      },
      "ip_allowlist.config.activated": {
        "configs": [
          {
            "id": "id",
            "name": "name"
          }
        ]
      },
      "ip_allowlist.config.deactivated": {
        "configs": [
          {
            "id": "id",
            "name": "name"
          }
        ]
      },
      "ip_allowlist.created": {
        "id": "id",
        "allowed_ips": [
          "string"
        ],
        "name": "name"
      },
      "ip_allowlist.deleted": {
        "id": "id",
        "allowed_ips": [
          "string"
        ],
        "name": "name"
      },
      "ip_allowlist.updated": {
        "id": "id",
        "allowed_ips": [
          "string"
        ]
      },
      "login.failed": {
        "error_code": "error_code",
        "error_message": "error_message"
      },
      "login.succeeded": {},
      "logout.failed": {
        "error_code": "error_code",
        "error_message": "error_message"
      },
      "logout.succeeded": {},
      "organization.updated": {
        "id": "id",
        "changes_requested": {
          "api_call_logging": "api_call_logging",
          "api_call_logging_project_ids": "api_call_logging_project_ids",
          "description": "description",
          "name": "name",
          "threads_ui_visibility": "threads_ui_visibility",
          "title": "title",
          "usage_dashboard_visibility": "usage_dashboard_visibility"
        }
      },
      "project": {
        "id": "id",
        "name": "name"
      },
      "project.archived": {
        "id": "id"
      },
      "project.created": {
        "id": "id",
        "data": {
          "name": "name",
          "title": "title"
        }
      },
      "project.deleted": {
        "id": "id"
      },
      "project.updated": {
        "id": "id",
        "changes_requested": {
          "title": "title"
        }
      },
      "rate_limit.deleted": {
        "id": "id"
      },
      "rate_limit.updated": {
        "id": "id",
        "changes_requested": {
          "batch_1_day_max_input_tokens": 0,
          "max_audio_megabytes_per_1_minute": 0,
          "max_images_per_1_minute": 0,
          "max_requests_per_1_day": 0,
          "max_requests_per_1_minute": 0,
          "max_tokens_per_1_minute": 0
        }
      },
      "role.assignment.created": {
        "id": "id",
        "principal_id": "principal_id",
        "principal_type": "principal_type",
        "resource_id": "resource_id",
        "resource_type": "resource_type"
      },
      "role.assignment.deleted": {
        "id": "id",
        "principal_id": "principal_id",
        "principal_type": "principal_type",
        "resource_id": "resource_id",
        "resource_type": "resource_type"
      },
      "role.bound_to_resource": {
        "id": "id",
        "connector_id": "connector_id",
        "connector_name": "connector_name",
        "enabled": true,
        "permissions": [
          "string"
        ],
        "resource_id": "resource_id",
        "resource_type": "resource_type",
        "role_id": "role_id",
        "source": "role_toggle",
        "workspace_id": "workspace_id"
      },
      "role.created": {
        "id": "id",
        "permissions": [
          "string"
        ],
        "resource_id": "resource_id",
        "resource_type": "resource_type",
        "role_name": "role_name"
      },
      "role.deleted": {
        "id": "id"
      },
      "role.unbound_from_resource": {
        "id": "id",
        "connector_id": "connector_id",
        "connector_name": "connector_name",
        "enabled": true,
        "permissions": [
          "string"
        ],
        "resource_id": "resource_id",
        "resource_type": "resource_type",
        "role_id": "role_id",
        "source": "role_toggle",
        "workspace_id": "workspace_id"
      },
      "role.updated": {
        "id": "id",
        "changes_requested": {
          "description": "description",
          "metadata": {},
          "permissions_added": [
            "string"
          ],
          "permissions_removed": [
            "string"
          ],
          "resource_id": "resource_id",
          "resource_type": "resource_type",
          "role_name": "role_name"
        }
      },
      "scim.disabled": {
        "id": "id"
      },
      "scim.enabled": {
        "id": "id"
      },
      "service_account.created": {
        "id": "id",
        "data": {
          "role": "role"
        }
      },
      "service_account.deleted": {
        "id": "id"
      },
      "service_account.updated": {
        "id": "id",
        "changes_requested": {
          "role": "role"
        }
      },
      "user.added": {
        "id": "id",
        "data": {
          "role": "role"
        }
      },
      "user.deleted": {
        "id": "id"
      },
      "user.updated": {
        "id": "id",
        "changes_requested": {
          "role": "role"
        }
      },
      "workload_identity_provider_mapping.created": {
        "id": "id",
        "data": {},
        "identity_provider_id": "identity_provider_id"
      },
      "workload_identity_provider_mapping.deleted": {
        "id": "id",
        "identity_provider_id": "identity_provider_id",
        "project_id": "project_id",
        "service_account_id": "service_account_id"
      },
      "workload_identity_provider_mapping.updated": {
        "id": "id",
        "changes_requested": {},
        "identity_provider_id": "identity_provider_id"
      },
      "workload_identity_provider.created": {
        "id": "id",
        "data": {}
      },
      "workload_identity_provider.deleted": {
        "id": "id",
        "name": "name"
      },
      "workload_identity_provider.updated": {
        "id": "id",
        "changes_requested": {}
      }
    }
  ],
  "has_more": true,
  "object": "list",
  "first_id": "audit_log-defb456h8dks",
  "last_id": "audit_log-hnbkd8s93s"
}
```

### Example

```http
curl https://api.openai.com/v1/organization/audit_logs \
-H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
-H "Content-Type: application/json"
```

#### Response

```json
{
    "object": "list",
    "data": [
        {
            "id": "audit_log-xxx_yyyymmdd",
            "type": "project.archived",
            "effective_at": 1722461446,
            "actor": {
                "type": "api_key",
                "api_key": {
                    "type": "user",
                    "user": {
                        "id": "user-xxx",
                        "email": "user@example.com"
                    }
                }
            },
            "project.archived": {
                "id": "proj_abc"
            }
        },
        {
            "id": "audit_log-yyy__20240101",
            "type": "api_key.updated",
            "effective_at": 1720804190,
            "actor": {
                "type": "session",
                "session": {
                    "user": {
                        "id": "user-xxx",
                        "email": "user@example.com"
                    },
                    "ip_address": "127.0.0.1",
                    "user_agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4472.124 Safari/537.36",
                    "ja3": "a497151ce4338a12c4418c44d375173e",
                    "ja4": "q13d0313h3_55b375c5d22e_c7319ce65786",
                    "ip_address_details": {
                      "country": "US",
                      "city": "San Francisco",
                      "region": "California",
                      "region_code": "CA",
                      "asn": "1234",
                      "latitude": "37.77490",
                      "longitude": "-122.41940"
                    }
                }
            },
            "api_key.updated": {
                "id": "key_xxxx",
                "data": {
                    "scopes": ["resource_2.operation_2"]
                }
            }
        }
    ],
    "first_id": "audit_log-xxx__20240101",
    "last_id": "audit_log_yyy__20240101",
    "has_more": true
}
```

## Domain Types

### Audit Log List Response

- `AuditLogListResponse object { id, effective_at, type, 59 more }`

  A log of a user action or configuration change within this organization.

  - `id: string`

    The ID of this log.

  - `effective_at: number`

    The Unix timestamp (in seconds) of the event.

  - `type: "api_key.created" or "api_key.updated" or "api_key.deleted" or 146 more`

    The event type.

    - `"api_key.created"`

    - `"api_key.updated"`

    - `"api_key.deleted"`

    - `"certificate.created"`

    - `"certificate.updated"`

    - `"certificate.deleted"`

    - `"certificates.activated"`

    - `"certificates.deactivated"`

    - `"checkpoint.permission.created"`

    - `"checkpoint.permission.deleted"`

    - `"external_key.registered"`

    - `"external_key.removed"`

    - `"external_storage.registered"`

    - `"external_storage.removed"`

    - `"group.created"`

    - `"group.updated"`

    - `"group.deleted"`

    - `"invite.sent"`

    - `"invite.accepted"`

    - `"invite.deleted"`

    - `"ip_allowlist.created"`

    - `"ip_allowlist.updated"`

    - `"ip_allowlist.deleted"`

    - `"ip_allowlist.config.activated"`

    - `"ip_allowlist.config.deactivated"`

    - `"login.succeeded"`

    - `"login.failed"`

    - `"logout.succeeded"`

    - `"logout.failed"`

    - `"organization.updated"`

    - `"project.created"`

    - `"project.updated"`

    - `"project.archived"`

    - `"project.deleted"`

    - `"rate_limit.updated"`

    - `"rate_limit.deleted"`

    - `"resource.deleted"`

    - `"tunnel.created"`

    - `"tunnel.updated"`

    - `"tunnel.deleted"`

    - `"workload_identity_provider.created"`

    - `"workload_identity_provider.updated"`

    - `"workload_identity_provider.deleted"`

    - `"workload_identity_provider_mapping.created"`

    - `"workload_identity_provider_mapping.updated"`

    - `"workload_identity_provider_mapping.deleted"`

    - `"role.created"`

    - `"role.updated"`

    - `"role.deleted"`

    - `"role.assignment.created"`

    - `"role.assignment.deleted"`

    - `"role.bound_to_resource"`

    - `"role.unbound_from_resource"`

    - `"scim.enabled"`

    - `"scim.disabled"`

    - `"service_account.created"`

    - `"service_account.updated"`

    - `"service_account.deleted"`

    - `"user.added"`

    - `"user.updated"`

    - `"user.deleted"`

    - `"tenant.metadata.updated"`

    - `"tenant.microsoft_entra_mapping.upserted"`

    - `"tenant.microsoft_entra_mapping.deleted"`

    - `"tenant.workload_identity.provider.created"`

    - `"tenant.workload_identity.provider.updated"`

    - `"tenant.workload_identity.provider.archived"`

    - `"tenant.workload_identity.mapping.created"`

    - `"tenant.workload_identity.mapping.updated"`

    - `"tenant.workload_identity.mapping.archived"`

    - `"tenant.workload_identity.binding.created"`

    - `"tenant.workload_identity.principal.provisioned"`

    - `"tenant.workload_identity.access_token.issued"`

    - `"tenant.admin_api_key.created"`

    - `"tenant.admin_api_key.updated"`

    - `"tenant.admin_api_key.deleted"`

    - `"tenant.project_api_key.created"`

    - `"tenant.trusted_access.business_verification.started"`

    - `"tenant.trusted_access.application.submitted"`

    - `"tenant.chatgpt_access_token.revoked"`

    - `"tenant.migration.completed"`

    - `"tenant.sso.migrated"`

    - `"tenant.domains.migrated"`

    - `"tenant.sso_connection.created"`

    - `"tenant.sso_connection.updated"`

    - `"tenant.sso_connection.deleted"`

    - `"tenant.sso_connection.setup.started"`

    - `"tenant.policy.created"`

    - `"tenant.policy.updated"`

    - `"tenant.policy.deleted"`

    - `"tenant.policy.attached"`

    - `"tenant.policy.detached"`

    - `"tenant.principal_authentication_policy.resolved"`

    - `"tenant.scim.setup.started"`

    - `"tenant.scim.deletion.requested"`

    - `"tenant.scim.directory.created"`

    - `"tenant.product_access_policy.updated"`

    - `"tenant.resource_share_grant.created"`

    - `"tenant.resource_share_grant.updated"`

    - `"tenant.resource_share_grant.accepted"`

    - `"tenant.resource_share_grant.declined"`

    - `"tenant.resource_share_grant.revoked"`

    - `"tenant.resource_share_grant.deleted"`

    - `"tenant.service_account.updated"`

    - `"tenant.service_account.deleted"`

    - `"tenant.service_account.token.revoked"`

    - `"tenant.billing.overage_limit.updated"`

    - `"tenant.billing.alerts.updated"`

    - `"tenant.billing.info.updated"`

    - `"tenant.usage_limit.workspace.updated"`

    - `"tenant.usage_limit.group.updated"`

    - `"tenant.usage_limit.user.updated"`

    - `"tenant.usage_limit.increase_request.updated"`

    - `"tenant.usage_limit.increase_request.resolved"`

    - `"tenant.group.created"`

    - `"tenant.group.updated"`

    - `"tenant.group.deleted"`

    - `"tenant.group.member.added"`

    - `"tenant.group.member.removed"`

    - `"tenant.migration_rollout.status.updated"`

    - `"tenant.migration_rollout.tier.updated"`

    - `"tenant.role.metadata.updated"`

    - `"tenant.custom_role.created"`

    - `"tenant.custom_role.updated"`

    - `"tenant.custom_role.deleted"`

    - `"tenant.role_assignment.created"`

    - `"tenant.role_assignment.deleted"`

    - `"tenant.resource_role_assignment.created"`

    - `"tenant.resource_role_assignment.deleted"`

    - `"tenant.resource_access.updated"`

    - `"tenant.resource_access.deleted"`

    - `"tenant.ads_account.onboarding.redemption"`

    - `"tenant.session_policy.created"`

    - `"tenant.session_policy.updated"`

    - `"tenant.session_policy.deleted"`

    - `"tenant.session_revocation.started"`

    - `"tenant.third_party_app_policy.updated"`

    - `"tenant.user.added"`

    - `"tenant.user.updated"`

    - `"tenant.user.removed"`

    - `"tenant.user.looked_up"`

    - `"tenant.user.invited"`

    - `"tenant.membership.revoked"`

    - `"tenant.api_organization_invite.upserted"`

    - `"tenant.api_organization_invite.deleted"`

    - `"tenant.chatgpt_workspace_invite.upserted"`

    - `"tenant.membership.accepted"`

    - `"tenant.membership.declined"`

    - `"tenant.workspace_invite_email_settings.updated"`

  - `actor: optional object { api_key, session, type }  or null`

    The actor who performed the audit logged action.

    - `api_key: optional object { id, service_account, type, user }`

      The API Key used to perform the audit logged action.

      - `id: optional string`

        The tracking id of the API key.

      - `service_account: optional object { id }`

        The service account that performed the audit logged action.

        - `id: optional string`

          The service account id.

      - `type: optional "user" or "service_account"`

        The type of API key. Can be either `user` or `service_account`.

        - `"user"`

        - `"service_account"`

      - `user: optional object { id, email }`

        The user who performed the audit logged action.

        - `id: optional string`

          The user id.

        - `email: optional string`

          The user email.

    - `session: optional object { ip_address, user }`

      The session in which the audit logged action was performed.

      - `ip_address: optional string`

        The IP address from which the action was performed.

      - `user: optional object { id, email }`

        The user who performed the audit logged action.

        - `id: optional string`

          The user id.

        - `email: optional string`

          The user email.

    - `type: optional "session" or "api_key"`

      The type of actor. Is either `session` or `api_key`.

      - `"session"`

      - `"api_key"`

  - `"api_key.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The tracking ID of the API key.

    - `data: optional object { scopes }`

      The payload used to create the API key.

      - `scopes: optional array of string`

        A list of scopes allowed for the API key, e.g. `["api.model.request"]`

  - `"api_key.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The tracking ID of the API key.

  - `"api_key.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The tracking ID of the API key.

    - `changes_requested: optional object { scopes }`

      The payload used to update the API key.

      - `scopes: optional array of string`

        A list of scopes allowed for the API key, e.g. `["api.model.request"]`

  - `"certificate.created": optional object { id, name }`

    The details for events with this `type`.

    - `id: optional string`

      The certificate ID.

    - `name: optional string`

      The name of the certificate.

  - `"certificate.deleted": optional object { id, certificate, name }`

    The details for events with this `type`.

    - `id: optional string`

      The certificate ID.

    - `certificate: optional string`

      The certificate content in PEM format.

    - `name: optional string`

      The name of the certificate.

  - `"certificate.updated": optional object { id, name }`

    The details for events with this `type`.

    - `id: optional string`

      The certificate ID.

    - `name: optional string`

      The name of the certificate.

  - `"certificates.activated": optional object { certificates }`

    The details for events with this `type`.

    - `certificates: optional array of object { id, name }`

      - `id: optional string`

        The certificate ID.

      - `name: optional string`

        The name of the certificate.

  - `"certificates.deactivated": optional object { certificates }`

    The details for events with this `type`.

    - `certificates: optional array of object { id, name }`

      - `id: optional string`

        The certificate ID.

      - `name: optional string`

        The name of the certificate.

  - `"checkpoint.permission.created": optional object { id, data }`

    The project and fine-tuned model checkpoint that the checkpoint permission was created for.

    - `id: optional string`

      The ID of the checkpoint permission.

    - `data: optional object { fine_tuned_model_checkpoint, project_id }`

      The payload used to create the checkpoint permission.

      - `fine_tuned_model_checkpoint: optional string`

        The ID of the fine-tuned model checkpoint.

      - `project_id: optional string`

        The ID of the project that the checkpoint permission was created for.

  - `"checkpoint.permission.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the checkpoint permission.

  - `"external_key.registered": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the external key configuration.

    - `data: optional unknown`

      The configuration for the external key.

  - `"external_key.removed": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the external key configuration.

  - `"external_storage.registered": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the external storage configuration.

    - `data: optional object { geography, provider }`

      The configuration for the external storage.

      - `geography: optional string`

        The OpenAI geography derived from the storage region.

      - `provider: optional AwsExternalStorageProvider or AzureExternalStorageProvider or GcpExternalStorageProvider or OciExternalStorageProvider`

        The external storage provider configuration.

        - `AwsExternalStorageProvider object { account_id, bucket, external_id, 3 more }`

          - `account_id: string`

          - `bucket: string`

          - `external_id: string`

          - `region: string`

          - `role_arn: string`

          - `type: "aws"`

            - `"aws"`

        - `AzureExternalStorageProvider object { account_name, container, region, 4 more }`

          - `account_name: string`

          - `container: string`

          - `region: string`

          - `resource_group: string`

          - `subscription_id: string`

          - `tenant_id: string`

          - `type: "azure"`

            - `"azure"`

        - `GcpExternalStorageProvider object { audience, bucket, region, 4 more }`

          - `audience: string`

          - `bucket: string`

          - `region: string`

          - `type: "gcp"`

            - `"gcp"`

          - `workload_identity_pool_id: string`

          - `workload_identity_project_number: string`

          - `workload_identity_provider_id: string`

        - `OciExternalStorageProvider object { bucket, region, tenancy_ocid, type }`

          - `bucket: string`

          - `region: string`

          - `tenancy_ocid: string`

          - `type: "oci"`

            - `"oci"`

  - `"external_storage.removed": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the external storage configuration.

  - `"group.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the group.

    - `data: optional object { group_name }`

      Information about the created group.

      - `group_name: optional string`

        The group name.

  - `"group.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the group.

  - `"group.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the group.

    - `changes_requested: optional object { group_name }`

      The payload used to update the group.

      - `group_name: optional string`

        The updated group name.

  - `"invite.accepted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the invite.

  - `"invite.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the invite.

  - `"invite.sent": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the invite.

    - `data: optional object { email, role }`

      The payload used to create the invite.

      - `email: optional string`

        The email invited to the organization.

      - `role: optional string`

        The role the email was invited to be. Is either `owner` or `member`.

  - `"ip_allowlist.config.activated": optional object { configs }`

    The details for events with this `type`.

    - `configs: optional array of object { id, name }`

      The configurations that were activated.

      - `id: optional string`

        The ID of the IP allowlist configuration.

      - `name: optional string`

        The name of the IP allowlist configuration.

  - `"ip_allowlist.config.deactivated": optional object { configs }`

    The details for events with this `type`.

    - `configs: optional array of object { id, name }`

      The configurations that were deactivated.

      - `id: optional string`

        The ID of the IP allowlist configuration.

      - `name: optional string`

        The name of the IP allowlist configuration.

  - `"ip_allowlist.created": optional object { id, allowed_ips, name }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the IP allowlist configuration.

    - `allowed_ips: optional array of string`

      The IP addresses or CIDR ranges included in the configuration.

    - `name: optional string`

      The name of the IP allowlist configuration.

  - `"ip_allowlist.deleted": optional object { id, allowed_ips, name }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the IP allowlist configuration.

    - `allowed_ips: optional array of string`

      The IP addresses or CIDR ranges that were in the configuration.

    - `name: optional string`

      The name of the IP allowlist configuration.

  - `"ip_allowlist.updated": optional object { id, allowed_ips }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the IP allowlist configuration.

    - `allowed_ips: optional array of string`

      The updated set of IP addresses or CIDR ranges in the configuration.

  - `"login.failed": optional object { error_code, error_message }`

    The details for events with this `type`.

    - `error_code: optional string`

      The error code of the failure.

    - `error_message: optional string`

      The error message of the failure.

  - `"login.succeeded": optional unknown`

    This event has no additional fields beyond the standard audit log attributes.

  - `"logout.failed": optional object { error_code, error_message }`

    The details for events with this `type`.

    - `error_code: optional string`

      The error code of the failure.

    - `error_message: optional string`

      The error message of the failure.

  - `"logout.succeeded": optional unknown`

    This event has no additional fields beyond the standard audit log attributes.

  - `"organization.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The organization ID.

    - `changes_requested: optional object { api_call_logging, api_call_logging_project_ids, description, 4 more }`

      The payload used to update the organization settings.

      - `api_call_logging: optional string`

        How your organization logs data from supported API calls. One of `disabled`, `enabled_per_call`, `enabled_for_all_projects`, or `enabled_for_selected_projects`

      - `api_call_logging_project_ids: optional string`

        The list of project ids if api_call_logging is set to `enabled_for_selected_projects`

      - `description: optional string`

        The organization description.

      - `name: optional string`

        The organization name.

      - `threads_ui_visibility: optional string`

        Visibility of the threads page which shows messages created with the Assistants API and Playground. One of `ANY_ROLE`, `OWNERS`, or `NONE`.

      - `title: optional string`

        The organization title.

      - `usage_dashboard_visibility: optional string`

        Visibility of the usage dashboard which shows activity and costs for your organization. One of `ANY_ROLE` or `OWNERS`.

  - `project: optional object { id, name }`

    The project that the action was scoped to. Absent for actions not scoped to projects. Note that any admin actions taken via Admin API keys are associated with the default project.

    - `id: optional string`

      The project ID.

    - `name: optional string`

      The project title.

  - `"project.archived": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

  - `"project.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

    - `data: optional object { name, title }`

      The payload used to create the project.

      - `name: optional string`

        The project name.

      - `title: optional string`

        The title of the project as seen on the dashboard.

  - `"project.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

  - `"project.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

    - `changes_requested: optional object { title }`

      The payload used to update the project.

      - `title: optional string`

        The title of the project as seen on the dashboard.

  - `"rate_limit.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The rate limit ID

  - `"rate_limit.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The rate limit ID

    - `changes_requested: optional object { batch_1_day_max_input_tokens, max_audio_megabytes_per_1_minute, max_images_per_1_minute, 3 more }`

      The payload used to update the rate limits.

      - `batch_1_day_max_input_tokens: optional number`

        The maximum batch input tokens per day. Only relevant for certain models.

      - `max_audio_megabytes_per_1_minute: optional number`

        The maximum audio megabytes per minute. Only relevant for certain models.

      - `max_images_per_1_minute: optional number`

        The maximum images per minute. Only relevant for certain models.

      - `max_requests_per_1_day: optional number`

        The maximum requests per day. Only relevant for certain models.

      - `max_requests_per_1_minute: optional number`

        The maximum requests per minute.

      - `max_tokens_per_1_minute: optional number`

        The maximum tokens per minute.

  - `"role.assignment.created": optional object { id, principal_id, principal_type, 2 more }`

    The details for events with this `type`.

    - `id: optional string`

      The identifier of the role assignment.

    - `principal_id: optional string`

      The principal (user or group) that received the role.

    - `principal_type: optional string`

      The type of principal (user or group) that received the role.

    - `resource_id: optional string`

      The resource the role assignment is scoped to.

    - `resource_type: optional string`

      The type of resource the role assignment is scoped to.

  - `"role.assignment.deleted": optional object { id, principal_id, principal_type, 2 more }`

    The details for events with this `type`.

    - `id: optional string`

      The identifier of the role assignment.

    - `principal_id: optional string`

      The principal (user or group) that had the role removed.

    - `principal_type: optional string`

      The type of principal (user or group) that had the role removed.

    - `resource_id: optional string`

      The resource the role assignment was scoped to.

    - `resource_type: optional string`

      The type of resource the role assignment was scoped to.

  - `"role.bound_to_resource": optional object { id, connector_id, connector_name, 7 more }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the resource the role was bound to. ChatGPT workspace connector resources use `<workspace_id>__<connector_id>`.

    - `connector_id: optional string`

      The connector ID for a ChatGPT workspace connector resource.

    - `connector_name: optional string`

      The connector display name for a ChatGPT workspace connector resource, or the connector ID when the display name could not be resolved.

    - `enabled: optional boolean`

      Whether the connector is enabled for the role.

    - `permissions: optional array of string`

      The permissions granted to the role for the resource.

    - `resource_id: optional string`

      The ID of the resource the role was bound to.

    - `resource_type: optional string`

      The type of resource the role was bound to.

    - `role_id: optional string`

      The ID of the role that was bound to the resource.

    - `source: optional "role_toggle" or "role_connector_update" or "role_delete" or 2 more`

      The connector role mutation path that produced the event.

      - `"role_toggle"`

      - `"role_connector_update"`

      - `"role_delete"`

      - `"workspace_permissions"`

      - `"connector_publish"`

    - `workspace_id: optional string`

      The workspace ID for a ChatGPT workspace connector resource.

  - `"role.created": optional object { id, permissions, resource_id, 2 more }`

    The details for events with this `type`.

    - `id: optional string`

      The role ID.

    - `permissions: optional array of string`

      The permissions granted by the role.

    - `resource_id: optional string`

      The resource the role is scoped to.

    - `resource_type: optional string`

      The type of resource the role belongs to.

    - `role_name: optional string`

      The name of the role.

  - `"role.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The role ID.

  - `"role.unbound_from_resource": optional object { id, connector_id, connector_name, 7 more }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the resource the role was unbound from. ChatGPT workspace connector resources use `<workspace_id>__<connector_id>`.

    - `connector_id: optional string`

      The connector ID for a ChatGPT workspace connector resource.

    - `connector_name: optional string`

      The connector display name for a ChatGPT workspace connector resource, or the connector ID when the display name could not be resolved.

    - `enabled: optional boolean`

      Whether the connector is enabled for the role.

    - `permissions: optional array of string`

      The permissions remaining for the role after the change.

    - `resource_id: optional string`

      The ID of the resource the role was unbound from.

    - `resource_type: optional string`

      The type of resource the role was unbound from.

    - `role_id: optional string`

      The ID of the role that was unbound from the resource.

    - `source: optional "role_toggle" or "role_connector_update" or "role_delete" or 2 more`

      The connector role mutation path that produced the event.

      - `"role_toggle"`

      - `"role_connector_update"`

      - `"role_delete"`

      - `"workspace_permissions"`

      - `"connector_publish"`

    - `workspace_id: optional string`

      The workspace ID for a ChatGPT workspace connector resource.

  - `"role.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The role ID.

    - `changes_requested: optional object { description, metadata, permissions_added, 4 more }`

      The payload used to update the role.

      - `description: optional string`

        The updated role description, when provided.

      - `metadata: optional unknown`

        Additional metadata stored on the role.

      - `permissions_added: optional array of string`

        The permissions added to the role.

      - `permissions_removed: optional array of string`

        The permissions removed from the role.

      - `resource_id: optional string`

        The resource the role is scoped to.

      - `resource_type: optional string`

        The type of resource the role belongs to.

      - `role_name: optional string`

        The updated role name, when provided.

  - `"scim.disabled": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the SCIM was disabled for.

  - `"scim.enabled": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The ID of the SCIM was enabled for.

  - `"service_account.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The service account ID.

    - `data: optional object { role }`

      The payload used to create the service account.

      - `role: optional string`

        The role of the service account. Is either `owner` or `member`.

  - `"service_account.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The service account ID.

  - `"service_account.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The service account ID.

    - `changes_requested: optional object { role }`

      The payload used to updated the service account.

      - `role: optional string`

        The role of the service account. Is either `owner` or `member`.

  - `"user.added": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The user ID.

    - `data: optional object { role }`

      The payload used to add the user to the project.

      - `role: optional string`

        The role of the user. Is either `owner` or `member`.

  - `"user.deleted": optional object { id }`

    The details for events with this `type`.

    - `id: optional string`

      The user ID.

  - `"user.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The project ID.

    - `changes_requested: optional object { role }`

      The payload used to update the user.

      - `role: optional string`

        The role of the user. Is either `owner` or `member`.

  - `"workload_identity_provider_mapping.created": optional object { id, data, identity_provider_id }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider mapping ID.

    - `data: optional unknown`

      The payload used to create the workload identity provider mapping.

    - `identity_provider_id: optional string`

      The workload identity provider ID.

  - `"workload_identity_provider_mapping.deleted": optional object { id, identity_provider_id, project_id, service_account_id }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider mapping ID.

    - `identity_provider_id: optional string`

      The workload identity provider ID.

    - `project_id: optional string`

      The project ID.

    - `service_account_id: optional string`

      The mapped service account ID.

  - `"workload_identity_provider_mapping.updated": optional object { id, changes_requested, identity_provider_id }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider mapping ID.

    - `changes_requested: optional unknown`

      The payload used to update the workload identity provider mapping.

    - `identity_provider_id: optional string`

      The workload identity provider ID.

  - `"workload_identity_provider.created": optional object { id, data }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider ID.

    - `data: optional unknown`

      The payload used to create the workload identity provider.

  - `"workload_identity_provider.deleted": optional object { id, name }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider ID.

    - `name: optional string`

      The workload identity provider name.

  - `"workload_identity_provider.updated": optional object { id, changes_requested }`

    The details for events with this `type`.

    - `id: optional string`

      The workload identity provider ID.

    - `changes_requested: optional unknown`

      The payload used to update the workload identity provider.

# Certificates

## Activate certificates for organization

**post** `/organization/certificates/activate`

Activate certificates at the organization level.

You can atomically and idempotently activate up to 10 certificates at a time.

### Body Parameters

- `certificate_ids: array of string`

### Returns

- `data: array of object { id, active, certificate_details, 3 more }`

  - `id: string`

    The identifier, which can be referenced in API endpoints

  - `active: boolean`

    Whether the certificate is currently active at the organization level.

  - `certificate_details: object { expires_at, valid_at }`

    - `expires_at: optional number`

      The Unix timestamp (in seconds) of when the certificate expires.

    - `valid_at: optional number`

      The Unix timestamp (in seconds) of when the certificate becomes valid.

  - `created_at: number`

    The Unix timestamp (in seconds) of when the certificate was uploaded.

  - `name: string or null`

    The name of the certificate.

  - `object: "organization.certificate"`

    The object type, which is always `organization.certificate`.

    - `"organization.certificate"`

- `object: "organization.certificate.activation"`

  The organization certificate activation result type.

  - `"organization.certificate.activation"`

### Example

```http
curl https://api.openai.com/v1/organization/certificates/activate \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
    -d '{
          "certificate_ids": [
            "cert_abc"
          ]
        }'
```

#### Response

```json
{
  "data": [
    {
      "id": "id",
      "active": true,
      "certificate_details": {
        "expires_at": 0,
        "valid_at": 0
      },
      "created_at": 0,
      "name": "name",
      "object": "organization.certificate"
    }
  ],
  "object": "organization.certificate.activation"
}
```

### Example

```http
curl https://api.openai.com/v1/organization/certificates/activate \
-H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
-H "Content-Type: application/json" \
-d '{
  "certificate_ids": ["cert_abc", "cert_def"]
}'
```

#### Response

```json
{
  "object": "organization.certificate.activation",
  "data": [
    {
      "object": "organization.certificate",
      "id": "cert_abc",
      "name": "My Example Certificate",
      "active": true,
      "created_at": 1234567,
      "certificate_details": {
        "valid_at": 12345667,
        "expires_at": 12345678
      }
    },
    {
      "object": "organization.certificate",
      "id": "cert_def",
      "name": "My Example Certificate 2",
      "active": true,
      "created_at": 1234567,
      "certificate_details": {
        "valid_at": 12345667,
        "expires_at": 12345678
      }
    }
  ]
}
```

## Upload certificate

**post** `/organization/certificates`

Upload a certificate to the organization. This does **not** automatically activate the certificate.

Organizations can upload up to 50 certificates.

### Body Parameters

- `certificate: string`

  The certificate content in PEM format

- `name: optional string`

  An optional name for the certificate

### Returns

- `Certificate object { id, certificate_details, created_at, 3 more }`

  Represents an individual `certificate` uploaded to the organization.

  - `id: string`

    The identifier, which can be referenced in API endpoints

  - `certificate_details: object { content, expires_at, valid_at }`

    - `content: optional string`

      The content of the certificate in PEM format.

    - `expires_at: optional number`

      The Unix timestamp (in seconds) of when the certificate expires.

    - `valid_at: optional number`

      The Unix timestamp (in seconds) of when the certificate becomes valid.

  - `created_at: number`

    The Unix timestamp (in seconds) of when the certificate was uploaded.

  - `name: string or null`

    The name of the certificate.

  - `object: "certificate" or "organization.certificate" or "organization.project.certificate"`

    The object type.

    - If creating, updating, or getting a specific certificate, the object type is `certificate`.
    - If listing, activating, or deactivating certificates for the organization, the object type is `organization.certificate`.
    - If listing, activating, or deactivating certificates for a project, the object type is `organization.project.certificate`.

    - `"certificate"`

    - `"organization.certificate"`

    - `"organization.project.certificate"`

  - `active: optional boolean`

    Whether the certificate is currently active at the specified scope. Not returned when getting details for a specific certificate.

### Example

```http
curl https://api.openai.com/v1/organization/certificates \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
    -d '{
          "certificate": "certificate"
        }'
```

#### Response

```json
{
  "id": "id",
  "certificate_details": {
    "content": "content",
    "expires_at": 0,
    "valid_at": 0
  },
  "created_at": 0,
  "name": "name",
  "object": "certificate",
  "active": true
}
```

### Example

```http
curl -X POST https://api.openai.com/v1/organization/certificates \
-H "Authorization: Bearer $OPENAI_ADMIN_KEY" \
-H "Content-Type: application/json" \
-d '{
  "name": "My Example Certificate",
  "certificate": "-----BEGIN CERTIFICATE-----\\nMIIDeT...\\n-----END CERTIFICATE-----"
}'
```

#### Response

```json
{
  "object": "certificate",
  "id": "cert_abc",
  "name": "My Example Certificate",
  "created_at": 1234567,
  "certificate_details": {
    "valid_at": 12345667,
    "expires_at": 12345678
  }
}
```

## Deactivate certificates for organization

**post** `/organization/certificates/deactivate`

Deactivate certificates at the organization level.

You can atomically and idempotently deactivate up to 10 certificates at a time.

### Body Parameters

- `certificate_ids: array of string`

### Returns

- `data: array of object { id, active, certificate_details, 3 more }`

  - `id: string`

    The identifier, which can be referenced in API endpoints

  - `active: boolean`

    Whether the certificate is currently active at the organization level.

  - `certificate_details: object { expires_at, valid_at }`

    - `expires_at: optional number`

      The Unix timestamp (in seconds) of when the certificate expires.

    - `valid_at: optional number`

      The Unix timestamp (in seconds) of when the certificate becomes valid.

  - `created_at: number`

    The Unix timestamp (in seconds) of when the certificate was uploaded.

  - `name: string or null`

    The name of the certificate.

[...]
